/*
  manaemori --- a keeperhack for manae
  mmhackentry.c --- entry module
  Copyright 2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
  manaemori hacks SysHandleEvent.
*/


// #include <System/SysAll.h>
// #include <UI/UIAll.h>
// #include <System/FeatureMgr.h>
// #include <UI/SonyChars.h>
#include <PalmOS.h>
#include "manae.h"
#include "manaemori.h"

void ErrorPrintNum(Int i, SWord x, SWord y)
{
  Char s[35];
  StrPrintF(s, "manae error: %d", i);
  WinDrawChars(s, StrLen(s), x, y);
}

void ErrorPrintHex(ULong hex, SWord x, SWord y)
{
  Char s[15];

  StrPrintF(s, "%lx", hex);
  WinDrawChars(s, StrLen(s), x, y);
}
/*
static void ErrorPrint(CharPtr cP, SWord x, SWord y)
{
  WinDrawChars(cP, StrLen(cP), x, y);
}
*/
static Word EmacsKeyTrans(Word c)
{
  Word transC;
  //  WinDrawChars("*", 1, 0, 0);
  switch (c) {
  case ('f' - 'a' + 1):
  case 0x0109:
    transC = rightArrowChr;
    break;
  case ('b' - 'a' + 1):
  case 0x0101:
    transC = leftArrowChr;
    break;
  case ('p' - 'a' + 1):
    transC = upArrowChr;
    break;
  case ('n' - 'a' + 1):
  case 0x0103:
    transC = downArrowChr;
    break;
/* don't work...sigh...
  case ('s' - 'a' + 1):
    transC = findChr;
    break;
  case ('w' - 'a' + 1):
    transC = cutChr;
    break;
  case ('y' - 'a' + 1):
    transC = pasteChr;
    break;
*/
  default:
    transC = c;
    break;
  }
  /*
  if (c == transC) {
    WinDrawChars("f", 1, 0, 0);
  } else {
    WinDrawChars("t", 1, 0, 0);
  }
  */
  return(transC);
}

Boolean ManaeMori(EventPtr eventP)
{
  DWord ftrVal;
  Boolean (*oldtrap)(EventPtr);
  Boolean ret;
  GlobalPtr g;

  FtrGet(MMCREATOR, 1000, &ftrVal);
  oldtrap = (Boolean (*)(EventPtr))ftrVal;

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) == 0) { 
    g->realChr = nullChr;
    if (eventP->eType != keyDownEvent) {
      ret = (*oldtrap)(eventP);
      return(ret);
    }
#ifdef DEBUG
    {
      DWord c;
      FtrGet(CREATOR, 1051, &c);
      ErrorPrintHex(c, 0, 0);
      c++;
      FtrSet(CREATOR, 1051, c);
      ErrorPrintHex((ULong)eventP->data.keyDown.chr, 80, 0);
    }
#endif

    {
      Word c;
      if ((c = EmacsKeyTrans(eventP->data.keyDown.chr)) != 
	   eventP->data.keyDown.chr) {
	eventP->data.keyDown.chr = c;
	eventP->data.keyDown.modifiers = 0;
	ret = (*oldtrap)(eventP);
	return(ret);
      }
    }

    switch (g->kanjiMode) {
    case KANJI:
    case KANJIIN:
    case OKURIIN:
    case HENKAN:
      if (g->candsFrmFlg == true) {
	ret = (*oldtrap)(eventP);
	return(ret);
      }
      g->realChr = eventP->data.keyDown.chr;
      //      eventP->data.keyDown.chr = nullChr;
      eventP->data.keyDown.chr = crChr;
      // do not call old trap
      return(false);
      break;

    case NONKANJI:
    default:
      // do nothing
      break;
    }
  }
  ret = (*oldtrap)(eventP);
  return(ret);
}
